<?php
namespace Teknisa\GER\Services;

use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DataSource\Manager\Doctrine\NameProvider;
use Teknisa\Libs\Util\NewCode as NCode;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager\SQL\ManagerImpl;

class CrudService extends \Teknisa\Libs\Service\CRUD {

    
	const IMAGE_UPLOAD = 'IMAGE_UPLOAD';
	const FGFOTOSERVICO = 'FGFOTOSERVICO';
// 	const URLPREFIX = 'http://midiatest.teknisa.com/files/';
	
    /** @var ManagerImpl  */
    protected $dataSourceManager;
    /** @var Environment  */
    protected $environment;
    /** @var NewCode */
    protected $newCode;
    /** @var NameProvider */
    protected $nameProvider;
    /** @var ParameterBag  */
    protected $parameterBag;
    
	private $imgPathURL;
	
	public function __construct(ManagerImpl $dataSourceManager, Environment $environment, NCode $newCode, NameProvider $nameProvider, ParameterBag $parameterBag, $imgPathURL){
        parent::__construct($dataSourceManager, $environment, $newCode, $nameProvider, $parameterBag);
	    $this->imgPathURL = $imgPathURL;
	}
    
    /**
     * putImagePathFromTo
     * Put image path to field that match the database column
     * 
     * @param Zeedhi\Framework\DTO\Row $row
     * @param String $from
     * @param String $to
     * 
     * @return Void
     */
    private function putImagePathFromTo($row, $from, $to){
        if(!empty($row[$from] && isset($row[$from][0]['path'])) ){
            $row[$to] = $this->imgPathURL.$row[$from][0]['path'];
        }
        return $row;
    }
    
    public function save($dataSourceName, $rows) {
        $newRows = array();
        foreach($rows as $row){
            if(isset($rows[0]['IMAGE_UPLOAD'][0]['path']) && (isset($row['FGFOTOSERVICO'])) ){
                array_push($newRows, $this->putImagePathFromTo($row, self::IMAGE_UPLOAD, self::FGFOTOSERVICO) );
            } else {
                array_push($newRows, $row); 
            }
        }
        parent::save($dataSourceName, $newRows);
    }
    
}