-- =====================================================================
-- Sistema    : Comercial Comissaria
-- Programador: Leonardo Monteiro
-- Data       : 12/06/2001
-- Descrio  : Rotina para calcular os custos do Comercial Comissaria.
-- =====================================================================
-- PROCEDURES  DESCRIO
-- ----------  ---------
-- CUSTOPROD - Custo de Produtos
-- CUSTOREC  - Custo das Receitas
-- CUSTOSUBG - Custo dos Sub-grupos do Manual e da Apresentao
-- CUSTOSERV - Custo de Servios do Manual e Custo da Apresentao
-- CUSTOMAN  - Custo de Manuais
-- CUSTOCIA  - Custo de Comapnhia
-- =====================================================================
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1100_COCSTP_CustosGerais.SQL
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\1100_COCSTPO.SQL
-- =====================================================================
-- VAR A CHAR(10)
-- VAR B NUMBER
-- VAR C NUMBER
-- VAR D NUMBER
-- VAR E NUMBER
-- VAR F NUMBER
-- BEGIN
--    :A := '0000000000';
--    :B := NULL;
-- END;
-- /
-- EXECUTE CUSTOMAN(:A,'M',:B,'N','S','S','9999','0007','0010','_000000048200010004_','29/05/2002','998',:C,:D,:E,:F)
-- =====================================================================
CREATE OR REPLACE PROCEDURE VERIFICA_ESPEPROD(
P_IDCOMPPADRAO IN ESPEPROD.IDCOMPPADRAO%TYPE,
P_CDPRODUTO    IN ESPEPROD.CDPRODUTO   %TYPE)
AS
V_DTVALESPEPRO ESPEPROD.DTVALESPEPRO%TYPE;
V_CONT         NUMBER;
V_CDARVPROD    PRODUTO.CDARVPROD   %TYPE;
V_IDPRODCOMISS PRODUTO.IDPRODCOMISS%TYPE;
BEGIN
	V_CONT := 0;
   SELECT MAX(DTVALESPEPRO)
   INTO V_DTVALESPEPRO
   FROM ESPEPROD
   WHERE (DTVALESPEPRO <= TRUNC(SYSDATE)) AND
         (IDCOMPPADRAO  = P_IDCOMPPADRAO) AND
         (CDPRODUTO     = P_CDPRODUTO   );
   IF V_DTVALESPEPRO IS NOT NULL THEN
      SELECT COUNT(*)
      INTO V_CONT
      FROM ESPEPROD
      WHERE (DTVALESPEPRO = V_DTVALESPEPRO) AND
            (IDCOMPPADRAO = P_IDCOMPPADRAO) AND
            (CDPRODUTO    = P_CDPRODUTO   );
      IF V_CONT > 1 THEN
      	SELECT CDARVPROD,IDPRODCOMISS
      	INTO V_CDARVPROD,V_IDPRODCOMISS
         FROM PRODUTO
         WHERE (CDPRODUTO = P_CDPRODUTO);
         IF V_IDPRODCOMISS = '3' THEN
				raise_application_error(-20502, 'A receita "'  ||V_CDARVPROD||'" possui mais de uma especificao cadastrada para o dia '||TO_CHAR(V_DTVALESPEPRO,'DD/MM/YYYY'||'.'), false);
         /*ELSIF V_IDPRODCOMISS = '2' THEN
				raise_application_error(-20502, 'O sub-grupo "'||V_CDARVPROD||'" possui mais de uma especificao cadastrada para o dia '||TO_CHAR(V_DTVALESPEPRO,'DD/MM/YYYY'||'.'), false);
         ELSIF V_IDPRODCOMISS = '2' THEN
				raise_application_error(-20502, 'O servio "'  ||V_CDARVPROD||'" possui mais de uma especificao cadastrada para o dia '||TO_CHAR(V_DTVALESPEPRO,'DD/MM/YYYY'||'.'), false);*/
         ELSE
				raise_application_error(-20502, 'O produto "'  ||V_CDARVPROD||'" possui mais de uma especificao cadastrada para o dia '||TO_CHAR(V_DTVALESPEPRO,'DD/MM/YYYY'||'.'), false);
         END IF;
      END IF;
   END IF;
END;
/
